<template>
    <div class="home">
        <h2>建構中...</h2>
        <svg width="100%" height="100%" viewBox="0 0 600 600">
            <rect
                v-for="index in 10"
                :key="index"
                :data-test="index"
                :fill="colorRadio(index / 10)"
                width="50"
                height="50"
            />
        </svg>
    </div>
</template>


<script>
// @ is an alias to /src
import _ from 'lodash'
import gsap from 'gsap'

export default {
    name: 'Home',
    data() {
        return {
            rects: null,
        }
    },
    computed: {},
    mounted() {
        const self = this
        self.rects = gsap.utils.toArray(self.$el.querySelectorAll('svg rect'))
        let delay = self.rects.length
        _.forEach(self.rects, (rect) => {
            delay -= 1
            _.delay(() => {
                self.loopTween({ times: 0, rect })
            }, delay * 300)
        })
    },
    methods: {
        loopTween(el) {
            const self = this
            gsap.to(el.rect, {
                duration: 2,
                ease: 'circ.inOut',
                keyframes: self.keyframes(el.times),
                onComplete() {
                    // eslint-disable-next-line no-param-reassign
                    el.times += 1
                    self.loopTween(el)
                },
            })
        },
        keyframes(times) {
            return [
                { x: this.distanceMapRangeX(100 - this.snapWrap(times)) },
                { y: this.distanceMapRangeY(100 - this.snapWrap(times)) },
                { x: this.distanceMapRangeX(this.snapWrap(times)) },
                { y: this.distanceMapRangeY(this.snapWrap(times)) },
            ]
        },
        distanceMapRangeX(x) {
            return gsap.utils.mapRange(0, 100, 0, 500, x)
        },
        distanceMapRangeY(y) {
            return gsap.utils.mapRange(0, 100, 0, 500, y)
        },
        snapWrap(index) {
            return gsap.utils.wrapYoyo([0, 10, 20, 30, 40], index)
        },
        colorRadio(percent) {
            return gsap.utils.interpolate('black', 'white', percent)
        },
    },
}
</script>

<style lang="scss" scoped>
.home {
  width: 600px;
  max-width: 100%;
  margin: 0 auto;
  svg {
    width: 100%;
  }
  padding-bottom: 5000px;
}
</style>

